Package com.sas.metadata.remote

# Interface Level

All Superinterfaces:
  `CMetadata`, `Feature`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

public interface Level extends Feature
An element of a dimension hierarchy. Levels describe the dimension from the highest (most summarized) level to the lowest (most detailed) level. For example, possible levels for a Geography dimension are Country, Region, State or Province, and City.

Attributes of Level are:

- `Cardinality`
- `UniqueName`
- `LevelType`
- `SortOrder`
- `SASFormat`

Associations of Level are:

- `Hierarchies`
- `OLAPProperties`
- `OwningDimension`
- `Aggregations`
- `CalculatedMembers`
- `HierarchyLevels`

## Usage

To create an instance of this Level, use the `factory` create methods.
Example: create a Level with name "Level_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     Level myObject = (Level) factory.createComplexMetadataObject(objectStore, "Level_Object", MetadataObjects.LEVEL, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_AGGREGATIONS_NAME`
  Constant used for the name of the Aggregations association.
  `static final String`
  `ASSOCIATION_CALCULATEDMEMBERS_NAME`
  Constant used for the name of the CalculatedMembers association.
  `static final String`
  `ASSOCIATION_HIERARCHIES_NAME`
  Constant used for the name of the Hierarchies association.
  `static final String`
  `ASSOCIATION_HIERARCHYLEVELS_NAME`
  Constant used for the name of the HierarchyLevels association.
  `static final String`
  `ASSOCIATION_OLAPPROPERTIES_NAME`
  Constant used for the name of the OLAPProperties association.
  `static final String`
  `ASSOCIATION_OWNINGDIMENSION_NAME`
  Constant used for the name of the OwningDimension association.
  `static final String`
  `ATTRIBUTE_CARDINALITY_NAME`
  Constant used for the name of the Cardinality attribute.
  `static final String`
  `ATTRIBUTE_LEVELTYPE_NAME`
  Constant used for the name of the LevelType attribute.
  `static final String`
  `ATTRIBUTE_SASFORMAT_NAME`
  Constant used for the name of the SASFormat attribute.
  `static final String`
  `ATTRIBUTE_SORTORDER_NAME`
  Constant used for the name of the SortOrder attribute.
  `static final String`
  `ATTRIBUTE_UNIQUENAME_NAME`
  Constant used for the name of the UniqueName attribute.

  ### Fields inherited from interface com.sas.metadata.remote.Feature

  `ASSOCIATION_SOURCEFEATUREMAPS_NAME, ASSOCIATION_TARGETFEATUREMAPS_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AssociationList`
  `getAggregations()`
  Gets the Association list of `Aggregations`
  `AssociationList`
  `getAggregations(boolean fGoToServer)`
  Gets the Associationlist of `Aggregations`
  `AssociationList`
  `getCalculatedMembers()`
  Gets the Association list of `CalculatedMembers`
  `AssociationList`
  `getCalculatedMembers(boolean fGoToServer)`
  Gets the Associationlist of `CalculatedMembers`
  `int`
  `getCardinality()`
  Gets the `int` value of `Cardinality`
  `int`
  `getCardinalityState()`
  Gets the Metadata State of `Cardinality`
  `AssociationList`
  `getHierarchies()`
  Gets the AssociationList of `Hierarchies`
  `AssociationList`
  `getHierarchies(boolean fGoToServer)`
  Gets the Associationlist of `Hierarchies`
  `AssociationList`
  `getHierarchyLevels()`
  Gets the Association list of `HierarchyLevels`
  `AssociationList`
  `getHierarchyLevels(boolean fGoToServer)`
  Gets the Associationlist of `HierarchyLevels`
  `int`
  `getLevelType()`
  Gets the `int` value of `LevelType`
  `int`
  `getLevelTypeState()`
  Gets the Metadata State of `LevelType`
  `AssociationList`
  `getOLAPProperties()`
  Gets the AssociationList of `OLAPProperties`
  `AssociationList`
  `getOLAPProperties(boolean fGoToServer)`
  Gets the Associationlist of `OLAPProperties`
  `Dimension`
  `getOwningDimension()`
  Gets the `Dimension` for `OwningDimension`
  `AssociationList`
  `getOwningDimensions()`
  Gets the AssociationList of `OwningDimensions`
  `AssociationList`
  `getOwningDimensions(boolean fGoToServer)`
  Gets the Associationlist of `OwningDimensions`
  `String`
  `getSASFormat()`
  Gets the `String` value of `SASFormat`
  `int`
  `getSASFormatMaxLength()`
  Gets the maximum length of `SASFormat`
  `int`
  `getSASFormatState()`
  Gets the Metadata State of `SASFormat`
  `String`
  `getSortOrder()`
  Gets the `String` value of `SortOrder`
  `int`
  `getSortOrderMaxLength()`
  Gets the maximum length of `SortOrder`
  `int`
  `getSortOrderState()`
  Gets the Metadata State of `SortOrder`
  `String`
  `getUniqueName()`
  Gets the `String` value of `UniqueName`
  `int`
  `getUniqueNameMaxLength()`
  Gets the maximum length of `UniqueName`
  `int`
  `getUniqueNameState()`
  Gets the Metadata State of `UniqueName`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `Hierarchies`
  `OLAPProperties`
  `OwningDimension`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `OwningDimension`
  `void`
  `setAggregations(AssociationList list)`
  Sets the `Aggregations` list to be `list`.
  `void`
  `setAggregations(AssociationList inObjects, int state)`
  Sets the entire Aggregations list to match the passed in AssociationList, sets the state of the Aggregations
  `void`
  `setCalculatedMembers(AssociationList list)`
  Sets the `CalculatedMembers` list to be `list`.
  `void`
  `setCalculatedMembers(AssociationList inObjects, int state)`
  Sets the entire CalculatedMembers list to match the passed in AssociationList, sets the state of the CalculatedMembers
  `void`
  `setCardinality(int inCardinality)`
  Sets the `Cardinality` value and sets the state to MetadataState.LOCAL.
  `void`
  `setCardinality(int inCardinality, int state)`
  Sets the `Cardinality` Metadata State.
  `void`
  `setCardinality(String inCardinality)`
  Sets the `Cardinality` value and sets the state to MetadataState.LOCAL.
  `void`
  `setCardinality(String inCardinality, int state)`
  Sets the `Cardinality` value and Metadata State.
  `void`
  `setCardinalityState(int state)`
  Sets the Metadata State of `Cardinality`.
  `void`
  `setHierarchies(AssociationList list)`
  Sets the `Hierarchies` list to be `list`.
  `void`
  `setHierarchies(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setHierarchyLevels(AssociationList list)`
  Sets the `HierarchyLevels` list to be `list`.
  `void`
  `setHierarchyLevels(AssociationList inObjects, int state)`
  Sets the entire HierarchyLevels list to match the passed in AssociationList, sets the state of the HierarchyLevels
  `void`
  `setLevelType(int inLevelType)`
  Sets the `LevelType` value and sets the state to MetadataState.LOCAL.
  `void`
  `setLevelType(int inLevelType, int state)`
  Sets the `LevelType` Metadata State.
  `void`
  `setLevelType(String inLevelType)`
  Sets the `LevelType` value and sets the state to MetadataState.LOCAL.
  `void`
  `setLevelType(String inLevelType, int state)`
  Sets the `LevelType` value and Metadata State.
  `void`
  `setLevelTypeState(int state)`
  Sets the Metadata State of `LevelType`.
  `void`
  `setOLAPProperties(AssociationList list)`
  Sets the `OLAPProperties` list to be `list`.
  `void`
  `setOLAPProperties(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setOwningDimension(Dimension inObject)`
  Sets the `OwningDimensions` list 0th element to be `inObject`.
  `void`
  `setOwningDimensions(AssociationList list)`
  Sets the `OwningDimensions` list to be `list`.
  `void`
  `setOwningDimensions(AssociationList list, int state)`
  Sets the `OwningDimensions` list to be `list`.
  `void`
  `setSASFormat(String inSASFormat)`
  Sets the `SASFormat` value and sets the state to MetadataState.LOCAL.
  `void`
  `setSASFormat(String inSASFormat, int state)`
  Sets the `SASFormat` Metadata State.
  `void`
  `setSASFormatState(int state)`
  Sets the Metadata State of `SASFormat`.
  `void`
  `setSortOrder(String inSortOrder)`
  Sets the `SortOrder` value and sets the state to MetadataState.LOCAL.
  `void`
  `setSortOrder(String inSortOrder, int state)`
  Sets the `SortOrder` Metadata State.
  `void`
  `setSortOrderState(int state)`
  Sets the Metadata State of `SortOrder`.
  `void`
  `setUniqueName(String inUniqueName)`
  Sets the `UniqueName` value and sets the state to MetadataState.LOCAL.
  `void`
  `setUniqueName(String inUniqueName, int state)`
  Sets the `UniqueName` Metadata State.
  `void`
  `setUniqueNameState(int state)`
  Sets the Metadata State of `UniqueName`.

  ### Methods inherited from interface com.sas.metadata.remote.Feature

  `getSourceFeatureMaps, getSourceFeatureMaps, getTargetFeatureMaps, getTargetFeatureMaps, setSourceFeatureMaps, setSourceFeatureMaps, setTargetFeatureMaps, setTargetFeatureMaps`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_CARDINALITY_NAME

    static final String ATTRIBUTE_CARDINALITY_NAME
    Constant used for the name of the Cardinality attribute.

    Cardinality: The number of members in this level.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_UNIQUENAME_NAME

    static final String ATTRIBUTE_UNIQUENAME_NAME
    Constant used for the name of the UniqueName attribute.

    UniqueName: The unique name for this level.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_LEVELTYPE_NAME

    static final String ATTRIBUTE_LEVELTYPE_NAME
    Constant used for the name of the LevelType attribute.

    LevelType: An enumeration of types of levels. From the OLEDB for OLAP spec. REGULAR 1 TIME 8 YEARS 16 HALF_YEARS 32 QUARTERS 64 MONTHS 128 WEEKS 256 DAYS 512 HOURS 1024 MINUTES 2048 SECONDS 4096

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_SORTORDER_NAME

    static final String ATTRIBUTE_SORTORDER_NAME
    Constant used for the name of the SortOrder attribute.

    SortOrder: This is an indication of the sort order of this column in this table. It can be ASCENDING, DESCENDING, ASCFORMATTED, DESFORMATTED, DSORDER.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_SASFORMAT_NAME

    static final String ATTRIBUTE_SASFORMAT_NAME
    Constant used for the name of the SASFormat attribute.

    SASFormat: SASFormat

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_HIERARCHIES_NAME

    static final String ASSOCIATION_HIERARCHIES_NAME
    Constant used for the name of the Hierarchies association.

    Hierarchies: The list of hierarchies that include this level.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_OLAPPROPERTIES_NAME

    static final String ASSOCIATION_OLAPPROPERTIES_NAME
    Constant used for the name of the OLAPProperties association.

    OLAPProperties: The list of OLAP properties for this level.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_OWNINGDIMENSION_NAME

    static final String ASSOCIATION_OWNINGDIMENSION_NAME
    Constant used for the name of the OwningDimension association.

    OwningDimension: The dimension that includes this level.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_AGGREGATIONS_NAME

    static final String ASSOCIATION_AGGREGATIONS_NAME
    Constant used for the name of the Aggregations association.

    Aggregations: The aggregations associated with this level.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_CALCULATEDMEMBERS_NAME

    static final String ASSOCIATION_CALCULATEDMEMBERS_NAME
    Constant used for the name of the CalculatedMembers association.

    CalculatedMembers: The calculated members for this level.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_HIERARCHYLEVELS_NAME

    static final String ASSOCIATION_HIERARCHYLEVELS_NAME
    Constant used for the name of the HierarchyLevels association.

    HierarchyLevels: The list of hierarchy levels associated with this level.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    `OwningDimension`
    Specified by:
      `initializeRequiredObjects` in interface `Feature`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `Hierarchies`
    `OLAPProperties`
    `OwningDimension`
    Specified by:
      `initializePredObjects` in interface `Feature`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCardinality

    int getCardinality() throws RemoteException
    Gets the `int` value of `Cardinality`
    Returns:
      The `Cardinality`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCardinalityState

    int getCardinalityState() throws RemoteException
    Gets the Metadata State of `Cardinality`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getUniqueName

    String getUniqueName() throws RemoteException
    Gets the `String` value of `UniqueName`
    Returns:
      The `UniqueName`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getUniqueNameState

    int getUniqueNameState() throws RemoteException
    Gets the Metadata State of `UniqueName`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getUniqueNameMaxLength

    int getUniqueNameMaxLength() throws RemoteException
    Gets the maximum length of `UniqueName`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getLevelType

    int getLevelType() throws RemoteException
    Gets the `int` value of `LevelType`
    Returns:
      The `LevelType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getLevelTypeState

    int getLevelTypeState() throws RemoteException
    Gets the Metadata State of `LevelType`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSortOrder

    String getSortOrder() throws RemoteException
    Gets the `String` value of `SortOrder`
    Returns:
      The `SortOrder`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSortOrderState

    int getSortOrderState() throws RemoteException
    Gets the Metadata State of `SortOrder`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSortOrderMaxLength

    int getSortOrderMaxLength() throws RemoteException
    Gets the maximum length of `SortOrder`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSASFormat

    String getSASFormat() throws RemoteException
    Gets the `String` value of `SASFormat`
    Returns:
      The `SASFormat`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSASFormatState

    int getSASFormatState() throws RemoteException
    Gets the Metadata State of `SASFormat`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSASFormatMaxLength

    int getSASFormatMaxLength() throws RemoteException
    Gets the maximum length of `SASFormat`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getHierarchies

    AssociationList getHierarchies() throws RemoteException, MdException
    Gets the AssociationList of `Hierarchies`
    Returns:
      Returns the AssociationList of `Hierarchies` which can be of type:
      Hierarchy
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOLAPProperties

    AssociationList getOLAPProperties() throws RemoteException, MdException
    Gets the AssociationList of `OLAPProperties`
    Returns:
      Returns the AssociationList of `OLAPProperties` which can be of type:
      OLAPProperty
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOwningDimensions

    AssociationList getOwningDimensions() throws RemoteException, MdException
    Gets the AssociationList of `OwningDimensions`
    Returns:
      Returns the AssociationList of `OwningDimensions` which can be of type:
      Dimension
      SharedDimension
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getOwningDimension

    Dimension getOwningDimension() throws RemoteException, MdException
    Gets the `Dimension` for `OwningDimension`
    Returns:
      The `Dimension` ( `null` if not set) of `OwningDimension`which can be of type:
      Dimension
      SharedDimension
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAggregations

    AssociationList getAggregations() throws RemoteException, MdException
    Gets the Association list of `Aggregations`
    Returns:
      The AssociationList of `Aggregations` which can be of type:
      Aggregation
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getCalculatedMembers

    AssociationList getCalculatedMembers() throws RemoteException, MdException
    Gets the Association list of `CalculatedMembers`
    Returns:
      The AssociationList of `CalculatedMembers` which can be of type:
      CalculatedMember
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getHierarchyLevels

    AssociationList getHierarchyLevels() throws RemoteException, MdException
    Gets the Association list of `HierarchyLevels`
    Returns:
      The AssociationList of `HierarchyLevels` which can be of type:
      HierarchyLevel
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getHierarchies

    AssociationList getHierarchies(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Hierarchies`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `Hierarchies` which can be of type:
      Hierarchy
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOLAPProperties

    AssociationList getOLAPProperties(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `OLAPProperties`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `OLAPProperties` which can be of type:
      OLAPProperty
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOwningDimensions

    AssociationList getOwningDimensions(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `OwningDimensions`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `OwningDimensions` which can be of type:
      Dimension
      SharedDimension
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAggregations

    AssociationList getAggregations(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Aggregations`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Aggregations` which can be of type:
      Aggregation
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getCalculatedMembers

    AssociationList getCalculatedMembers(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `CalculatedMembers`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `CalculatedMembers` which can be of type:
      CalculatedMember
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getHierarchyLevels

    AssociationList getHierarchyLevels(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `HierarchyLevels`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `HierarchyLevels` which can be of type:
      HierarchyLevel
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setCardinality

    void setCardinality(int inCardinality) throws RemoteException
    Sets the `Cardinality` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inCardinality` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCardinality

    void setCardinality(int inCardinality, int state) throws RemoteException
    Sets the `Cardinality` Metadata State.
    Parameters:
      `inCardinality` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCardinality

    void setCardinality(String inCardinality) throws RemoteException
    Sets the `Cardinality` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inCardinality` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCardinality

    void setCardinality(String inCardinality, int state) throws RemoteException
    Sets the `Cardinality` value and Metadata State.
    Parameters:
      `inCardinality` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCardinalityState

    void setCardinalityState(int state) throws RemoteException
    Sets the Metadata State of `Cardinality`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setUniqueName

    void setUniqueName(String inUniqueName) throws RemoteException
    Sets the `UniqueName` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inUniqueName` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setUniqueName

    void setUniqueName(String inUniqueName, int state) throws RemoteException
    Sets the `UniqueName` Metadata State.
    Parameters:
      `inUniqueName` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setUniqueNameState

    void setUniqueNameState(int state) throws RemoteException
    Sets the Metadata State of `UniqueName`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLevelType

    void setLevelType(int inLevelType) throws RemoteException
    Sets the `LevelType` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inLevelType` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLevelType

    void setLevelType(int inLevelType, int state) throws RemoteException
    Sets the `LevelType` Metadata State.
    Parameters:
      `inLevelType` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLevelType

    void setLevelType(String inLevelType) throws RemoteException
    Sets the `LevelType` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inLevelType` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLevelType

    void setLevelType(String inLevelType, int state) throws RemoteException
    Sets the `LevelType` value and Metadata State.
    Parameters:
      `inLevelType` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLevelTypeState

    void setLevelTypeState(int state) throws RemoteException
    Sets the Metadata State of `LevelType`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSortOrder

    void setSortOrder(String inSortOrder) throws RemoteException
    Sets the `SortOrder` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inSortOrder` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSortOrder

    void setSortOrder(String inSortOrder, int state) throws RemoteException
    Sets the `SortOrder` Metadata State.
    Parameters:
      `inSortOrder` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSortOrderState

    void setSortOrderState(int state) throws RemoteException
    Sets the Metadata State of `SortOrder`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSASFormat

    void setSASFormat(String inSASFormat) throws RemoteException
    Sets the `SASFormat` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inSASFormat` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSASFormat

    void setSASFormat(String inSASFormat, int state) throws RemoteException
    Sets the `SASFormat` Metadata State.
    Parameters:
      `inSASFormat` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSASFormatState

    void setSASFormatState(int state) throws RemoteException
    Sets the Metadata State of `SASFormat`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setHierarchies

    void setHierarchies(AssociationList list) throws RemoteException
    Sets the `Hierarchies` list to be `list`. Objects of which can be of type:
    Hierarchy
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setHierarchies

    void setHierarchies(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOLAPProperties

    void setOLAPProperties(AssociationList list) throws RemoteException
    Sets the `OLAPProperties` list to be `list`. Objects of which can be of type:
    OLAPProperty
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOLAPProperties

    void setOLAPProperties(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningDimensions

    void setOwningDimensions(AssociationList list) throws RemoteException
    Sets the `OwningDimensions` list to be `list`. Object of which can be of type:
    Dimension
    SharedDimension
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningDimensions

    void setOwningDimensions(AssociationList list, int state) throws RemoteException
    Sets the `OwningDimensions` list to be `list`. Object of which can be of type:
    Dimension
    SharedDimension
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningDimension

    void setOwningDimension(Dimension inObject) throws RemoteException
    Sets the `OwningDimensions` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Dimension
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAggregations

    void setAggregations(AssociationList list) throws RemoteException
    Sets the `Aggregations` list to be `list`. Objects of which can be of type:
    Aggregation
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAggregations

    void setAggregations(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Aggregations list to match the passed in AssociationList, sets the state of the Aggregations
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCalculatedMembers

    void setCalculatedMembers(AssociationList list) throws RemoteException
    Sets the `CalculatedMembers` list to be `list`. Objects of which can be of type:
    CalculatedMember
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCalculatedMembers

    void setCalculatedMembers(AssociationList inObjects, int state) throws RemoteException
    Sets the entire CalculatedMembers list to match the passed in AssociationList, sets the state of the CalculatedMembers
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setHierarchyLevels

    void setHierarchyLevels(AssociationList list) throws RemoteException
    Sets the `HierarchyLevels` list to be `list`. Objects of which can be of type:
    HierarchyLevel
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setHierarchyLevels

    void setHierarchyLevels(AssociationList inObjects, int state) throws RemoteException
    Sets the entire HierarchyLevels list to match the passed in AssociationList, sets the state of the HierarchyLevels
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.